package com.zipcodewilmington.looplabs;

/**
 * Created by leon on 1/29/18.
 * @ATTENTION_TO_STUDENTS You are forbidden from modifying the signature of this class.
 */
public final class IntegerDuplicateDeleter extends DuplicateDeleter<Integer> {

    public IntegerDuplicateDeleter(Integer[] intArray) {
        super(intArray);
    }

    @Override
    public Integer[] removeDuplicates(int maxNumberOfDuplications) {
        Integer[] newArr = createEmptyArrayWithOutDuplicatesNotExact(maxNumberOfDuplications);
        int index = 0;
        for(int i = 0; i < super.array.length; i ++){
            Integer number = super.array[i];
            int amount = findDuplicateOfElement(number);
            if(amount >= maxNumberOfDuplications){
                Integer[] indexes = getIndexsOfElements(number);
                i = indexes[indexes.length - 1];
            } else {
                newArr[index] = array[i];
                index ++;
            }
        }
        return newArr;
    }

    @Override
    public Integer[] removeDuplicatesExactly(int exactNumberOfDuplications) {
        Integer[] newArr = createEmptyArrayWithOutDuplicatesExact(exactNumberOfDuplications);
        int index = 0;
        for(int i = 0; i < super.array.length; i ++){
            int amount = findDuplicateOfElement(super.array[i]);
            Integer number = super.array[i];
            if(amount == exactNumberOfDuplications){
                Integer[] indexes = getIndexsOfElements(number);
                i = indexes[indexes.length - 1];
            } else {
                newArr[index] = number;
                index ++;
            }
        }
        return newArr;
    }

    public Integer[] createEmptyArrayWithOutDuplicatesNotExact(Integer maxNumberOfDuplications){
        int removeAmount = 0;
        for(int i = 0; i < array.length; i ++){
            Integer[] indexes = getIndexsOfElements(array[i]);
            if(indexes.length >= maxNumberOfDuplications) {
                removeAmount += indexes.length;
                i = indexes[indexes.length - 1];
            }
        }
        return new Integer[array.length - removeAmount];
    }

    public Integer[] createEmptyArrayWithOutDuplicatesExact(Integer maxNumberOfDuplications){
        int removeAmount = 0;
        for(int i = 0; i < array.length; i ++){
            Integer[] indexes = getIndexsOfElements(array[i]);
            if(indexes.length == maxNumberOfDuplications) {
                removeAmount += indexes.length;
                i = indexes[indexes.length - 1];
            }
        }
        return new Integer[array.length - removeAmount];
    }

    public Integer[] getIndexsOfElements(Integer element){
        Integer[] indexes = new Integer[findDuplicateOfElement(element)];
        for(int i = 0; i < indexes.length; i ++){
            for(int j = 0; j < super.array.length; j ++){
                if(super.array[j].equals(element)){
                    if(!contains(indexes, j)){
                        indexes[i] = j;
                        break;
                    }
                }
            }
        }
        return indexes;
    }

    public int findDuplicateOfElement(int element){
        int count = 0;
        for(Integer i : super.array){
            if(i.equals(element)){
                count ++;
            }
        }
        return count;
    }

    public boolean contains(Integer[] arr, Integer element){
        for(Integer integer : arr){
            if(integer != null) {
                if (integer.equals(element)) {
                    return true;
                }
            }
        }
        return false;
    }


//    public Integer[] removeElement(Integer[] arr, Integer element) {
//        boolean removed = false;
//        Integer[] newInt = new Integer[arr.length - 1];
//        for(int i = 0; i < newInt.length; i ++){
//            if(arr[i].equals(element)){
//                removed = true;
//            }
//            if(removed){
//                newInt[i] = arr[i + 1];
//            } else {
//                newInt[i] = i;
//            }
//        }
//        return newInt;
//    }

}
